
![LightAgent Banner](docs/images/lightagent-banner.jpg)
<div align="center">
  <p>
    <a href="https://opensource.org/licenses/Apache-2.0"><img src="https://img.shields.io/badge/License-Apache%202.0-blue.svg" alt="License"></a>
    <a href="https://github.com/wxai-space/LightAgent/releases"><img src="https://img.shields.io/github/release/wxai-space/LightAgent.svg" alt="GitHub release"></a>
    <a href="https://github.com/wxai-space/LightAgent/issues"><img src="https://img.shields.io/github/issues/wxai-space/LightAgent.svg" alt="GitHub issues"></a>
    <a href="https://github.com/wxai-space/LightAgent/stargazers"><img src="https://img.shields.io/github/stars/wxai-space/LightAgent.svg" alt="GitHub stars"></a>
    <a href="https://github.com/wxai-space/LightAgent/network"><img src="https://img.shields.io/github/forks/wxai-space/LightAgent.svg" alt="GitHub forks"></a>
    <a href="https://github.com/wxai-space/LightAgent/graphs/contributors"><img src="https://img.shields.io/github/contributors/wxai-space/LightAgent.svg" alt="GitHub contributors"></a>
    <a href="https://sufe-aiflm-lab.github.io/LightAgent/"><img src="https://img.shields.io/badge/docs-latest-brightgreen.svg" alt="Docs"></a>
    <a href="https://pypi.org/project/lightagent/"><img src="https://img.shields.io/pypi/v/lightagent.svg" alt="PyPI"></a>
    <a href="https://pypi.org/project/lightagent/"><img src="https://img.shields.io/pypi/dm/lightagent.svg" alt="Downloads"></a>
    <a href="https://pypi.org/project/lightagent/"><img src="https://img.shields.io/pypi/pyversions/lightagent.svg" alt="Python Version"></a>
    <a href="https://github.com/psf/black"><img src="https://img.shields.io/badge/code%20style-black-000000.svg" alt="Code Style"></a>
  </p>
</div>
<div align="center">
  <p>
    <a href="README.md">English</a> | 
    <a href="README.zh-CN.md">简体中文</a> | 
    <a href="README.zh-TW.md">繁體中文</a> | 
    <a href="README.es.md">Español</a> | 
    <a href="README.fr.md">Français</a> | 
    <a href="README.de.md">Deutsch</a> | 
    <a href="README.ja.md">日本語</a> | 
    <a href="README.ko.md">한국어</a> | 
    <a href="README.pt.md">Português</a> | 
    Русский
  </p>
</div>

<div align="center">
  <h1>LightAgent🚀（Следующее поколение агентного ИИ фреймворка）</h1>
</div>

**LightAgent** это исключительно легкий активный агентный фреймворк с памятью (`mem0`), инструментами (`Tools`), и деревом размышлений (`ToT`). Он поддерживает многомагистральное взаимодействие между агентами, автоматизированную генерацию инструментов, и тестирование агентов. Базовая модель поддерживает OpenAI, ChatGLM от Zhihui, большие модели от Baichuan, DeepSeek, и серии Qwen. В то же время, LightAgent поддерживает потоковые API сервисы OpenAI, без шва интегрируется с основными чат-фреймворками.🌟

---

## ✨ Характеристики

- **Легкий и эффективный** 🚀: Минималистичный дизайн, быстрая развертка, подходит для различных сценариев применения. (Нет LangChain, Нет LlamaIndex) 100% Python реализация, без дополнительных зависимостей, основной код всего 1000 строк, полностью с открытым исходным кодом.
- **Поддержка памяти** 🧠: Поддерживает настройку долгосрочной памяти для каждого пользователя, изначально поддерживает модуль памяти `mem0`, реализует автоматическое управление персонализированной памятью пользователя в процессе диалога, делая агента более интеллектуальным.
- **Самостоятельное обучение** 📚️: Каждый агент имеет способность к самостоятельному обучению, и администраторы с соответствующими правами могут управлять каждым агентом.
- **Интеграция инструментов** 🛠️: Поддерживает настраиваемые инструменты (`Tools`), автоматизированную генерацию инструментов, гибкое расширение для удовлетворения разнообразных потребностей.
- **Сложные цели** 🌳: Встроенный модуль дерева размышлений (ToT) поддерживает разбиение сложных задач и многошаговое вывод, повышая способность обработки задач.
- **Многомагистральное взаимодействие между агентами** 🤖: Простая реализация взаимодействия между несколькими агентами, встроенная LightSwarm реализует функции оценки намерений и передачи задач, что позволяет более интеллектуально обрабатывать пользовательский ввод и при необходимости передавать задачи другим агентам.
- **Независимое выполнение** 🤖: Выполнение вызова инструментов без вмешательства человека.
- **Поддержка нескольких моделей** 🔄: Совместимость с OpenAI, ChatGLM от Zhihui, Baichuan, Stepping Stars, DeepSeek, и сериями Qwen.
- **Потоковое API** 🌊: Поддерживает выход API в формате потока OpenAI, без шва интегрируется с основными чат-фреймворками для улучшения пользовательского опыта.
- **Генератор инструментов** 🚀: Просто передайте вашу документацию API [генератору инструментов], который автоматически создаст для вас уникальные инструменты, позволяя вам быстро построить сотни персонализированных инструментов всего за 1 час, повышая эффективность и освобождая вашу творческую потенцию.

## 🚧 Скоро в новом выпуске

- **Адаптивный механизм инструментов** 🛠️: Поддержка добавления неограниченного количества инструментов, выбор кандидатов среди десятков тысяч инструментов для фильтрации не относящихся инструментов перед отправкой контекста в большую модель, что может значительно снизить потребление токенов.
- **Интеллектуальная совместимость с памятью** 🛠️: Агент сможет делиться информацией и передавать сообщения между собой, реализуя сложное взаимодействие задач.
- **Самостоятельное обучение агента** 🧠️: Каждый агент будет обладать своей собственной способностью памяти сцены и сможет самостоятельно обучаться на основе диалогов пользователей.
- **Тестирование агентов** 📊: Встроенные инструменты тестирования агентов для удобной оценки и оптимизации созданного вами агента, выравнивание с бизнес-сценариями, постоянное повышение уровня интеллекта.

## Встроенная "мыслительная цепочка"
(Thinking Flow) методология, способная эффективно справляться с вызовами сложных ситуаций через системный, структурированный и гибкий мыслительный процесс.
 Конкретные шаги внедрения:
```text
Определение проблемы: Четкое обозначение ключевой проблемы и целей.

Сбор информации: Систематический сбор соответствующей информации и данных.

Разбиение проблемы: Разбивать сложную проблему на несколько подпунктов или модулей.

Многоаспектный анализ: Анализировать каждый подпункт с разных углов и уровней.

Установление связи: Определять взаимосвязи и зависимости между подпунктами.

Генерация решений: Предложить возможные решения для каждого подпункта.

Оценка и выбор: Оценивать осуществимость и влияние каждой из решений, выбирая оптимальный вариант.

Реализация и обратная связь: Реализовать выбранный вариант и вносить изменения на основании полученной обратной связи.
```

---
## 🌟 Почему стоит выбрать LightAgent?

- **С открытым исходным кодом и бесплатно** 💖: Полностью с открытым исходным кодом, поддерживаемый сообществом, постоянное обновление, приветствуются вклады!
- **Простота в использовании** 🎯: Подробная документация, множество примеров, быстрое освоение, легкая интеграция в ваш проект.
- **Поддержка сообщества** 👥: Активное сообщество разработчиков, готовое предоставить помощь и ответы в любое время.
- **Высокая производительность** ⚡: Оптимизированный дизайн, эффективная работа, удовлетворяющая потребности масштабируемых сцен.

---

## 🛠️ Быстрый старт

### Установка последней версии LightAgent

```bash
pip install lightagent
```

(опционально) Установить пакет Mem0 через pip:

```bash
pip install mem0ai
```

Или вы можете воспользоваться Mem0 на хостинговой платформе одним кликом, [нажмите здесь](https://www.mem0.ai/).


### Пример кода Hello world

```python
from LightAgent import LightAgent

# Инициализация агента
agent = LightAgent(model="gpt-4o-mini", api_key="your_api_key", base_url= "your_base_url")

# Запуск агента
response = agent.run("你好，你是谁？")
print(response)
```

### Настройка самосознания модели через системные подсказки

```python
from LightAgent import LightAgent

# Инициализация агента
agent = LightAgent(
     role="请记住你是LightAgent，一个可以帮助用户完成多工具使用的有用助手。",  # описание роли системы
     model="deepseek-chat",  # поддерживаемые модели: openai, chatglm, deepseek, qwen и др.
     api_key="your_api_key",  # замените вашим API ключом от вашего поставщика большой модели
     base_url="your_base_url",  # замените URL вашего поставщика большой модели
 )
# Запуск агента
response = agent.run("请问你是谁？")
print(response)
```

### Пример кода использования инструментов

```python
from LightAgent import LightAgent

# Определение инструмента
def get_weather(city_name: str) -> str:
    """
    Получить текущую погоду для `city_name`
    """
    return f"查询结果: {city_name} 天气晴"
# Определение информации об инструменте внутри функции
get_weather.tool_info = {
    "tool_name": "get_weather",
    "tool_description": "获取指定城市的当前天气信息",
    "tool_params": [
        {"name": "city_name", "description": "要查询的城市名称", "type": "string", "required": True},
    ]
}

tools = [get_weather]

# Инициализация агента
agent = LightAgent(model="qwen-turbo-2024-11-01", api_key="your_api_key", base_url= "your_base_url", tools=tools)

# Запуск агента
response = agent.run("请帮我查询一下上海的天气情况")
print(response)
```
Поддерживает неопределенное количество настраиваемых инструментов.

Несколько инструментов примеров: tools = ["search_news","get_weather","get_stock_realtime_data","get_stock_kline_data"]

---

## Подробности о функциях

### 1. Съемный автоматический модуль памяти (`mem0`)
LightAgent поддерживает внешнее расширение модуля памяти `mem0`, автоматическое управление памятью контекста и историческими данными, без необходимости ручной активации добавления памяти и поиска памяти разработчиком. С помощью модуля памяти агент может поддерживать согласованность контекста в многоразовых диалогах.

```python
# Включение модуля памяти

# Или используйте настраиваемый модуль памяти, приведем пример mem0 https://github.com/mem0ai/mem0/
from mem0 import Memory
from LightAgent import LightAgent
import os
from loguru import logger

class CustomMemory:
    def __init__(self):
        self.memories = []
        os.environ["OPENAI_API_KEY"] = "your_api_key"
        os.environ["OPENAI_API_BASE"] = "your_base_url"
        # Инициализация Mem0
        config = {
            "version": "v1.1"
        }
        # если вы хотите использовать qdrant для хранения памяти в векторном хранилище, измените config на следующий код
        # config = {
        #     "vector_store": {
        #         "provider": "qdrant",
        #         "config": {
        #             "host": "localhost",
        #             "port": 6333,
        #         }
        #     },
        #     "version": "v1.1"
        # }
        self.m = Memory.from_config(config_dict=config)

    def store(self, data: str, user_id):
        """Сохранить память разработчики могут самостоятельно изменить реализацию внутреннего метода хранения памяти, текущий пример - метод добавления памяти в mem0"""
        result = self.m.add(data, user_id=user_id)
        return result

    def retrieve(self, query: str, user_id):
        """Извлечь соответствующую память разработчики могут самостоятельно изменить реализацию метода извлечения, текущий пример - метод поиска памяти в mem0"""
        result = self.m.search(query, user_id=user_id)
        return result

agent = LightAgent(
        role="请记住你是LightAgent，一个可以帮助用户完成多工具使用的有用助手。",  # описание роли системы
        model="deepseek-chat",  # поддерживаемые модели: openai, chatglm, deepseek, qwen и др.
        api_key="your_api_key",  # замените вашим API ключом от вашего поставщика большой модели
        base_url="your_base_url",  # замените URL вашего поставщика большой модели
        memory=CustomMemory(),  # Включение функции памяти
        tree_of_thought=False,  # включение цепочки мыслей
    )

# Тест с памятью & если необходимо добавить инструменты, вы можете добавить tools к агенту для выполнения вызовов инструментов с памятью

user_id = "user_01"
logger.info("\n=========== next conversation ===========")
query = "介绍下三亚的有什么好玩的景点，身边很多朋友都去三亚旅游了，我也想去玩"
print(agent.run(query, stream=False, user_id=user_id))
logger.info("\n=========== next conversation ===========")
query = "我想去哪里旅游呢？"
print(agent.run(query, stream=False, user_id=user_id))
```

Вывод будет следующим:
```python
=========== next conversation ===========
2025-01-01 21:55:15.886 | INFO     | __main__:run_conversation:115 - 
开始思考问题: 介绍下三亚的有什么好玩的景点，身边很多朋友都去三亚旅游了，我也想去玩
2025-01-01 21:55:28.676 | INFO     | __main__:run_conversation:118 - Final Reply: 
三亚是中国海南省的一个热门旅游城市，以其美丽的海滩、热带气候和丰富的旅游资源而闻名。以下是一些三亚值得一游的景点：

1. **亚龙湾**：被誉为“东方夏威夷”，拥有绵长的沙滩和清澈的海水，是游泳、潜水和日光浴的理想之地。

2. **天涯海角**：这是一个著名的文化景观，以其壮丽的海景和浪漫的传说而吸引游客。这里的巨石上刻有“天涯”和“海角”字样，象征着永恒的爱情。

3. **南山文化旅游区**：这里有一个高达108米的南山海上观音像，是世界上最高的海上观音像。游客可以在这里体验佛教文化，参观寺庙和园林。

4. **蜈支洲岛**：这是一个小岛，以其原始的自然风光和丰富的水上活动而闻名。游客可以在这里进行潜水、浮潜、海钓等活动。

5. **大东海**：这是三亚市区内的一个海滩，以其便利的交通和丰富的夜生活而受到游客的喜爱。

6. **三亚湾**：这是一个长达22公里的海滩，是观赏日落的好地方。这里的海滩较为安静，适合喜欢宁静的游客。

7. **呀诺达雨林文化旅游区**：这是一个热带雨林公园，游客可以在这里体验热带雨林的自然风光，参与各种探险活动。

8. **鹿回头公园**：这是一个位于山顶的公园，可以俯瞰整个三亚市区和三亚湾的美景。这里还有一个关于鹿的美丽传说。

9. **西岛**：这是一个相对较为原始的小岛，以其宁静的海滩和丰富的海洋生物而吸引游客。

10. **三亚千古情**：这是一个大型的文化主题公园，通过表演和展览展示海南的历史和文化。

除了上述景点，三亚还有许多其他值得探索的地方，如热带植物园、海鲜市场等。三亚的美食也不容错过，尤其是新鲜的海鲜和热带水果。在规划旅行时，建议提前查看天气预报和景点开放时间，以确保有一个愉快的旅行体验。
2025-01-01 21:55:28.676 | INFO     | __main__:<module>:191 - 
=========== next conversation ===========
2025-01-01 21:55:28.676 | INFO     | __main__:run_conversation:115 - 
开始思考问题: 我想去哪里旅游呢？
发现相关记忆:
User wants to travel to Sanya
User's friends have traveled to Sanya。
2025-01-01 21:55:38.797 | INFO     | __main__:run_conversation:118 - Final Reply: 
根据用户之前提到的信息，用户的朋友已经去过三亚（Sanya），而用户自己也表达了对三亚的兴趣。因此，三亚可能是一个适合用户的旅游目的地。以下是一些关于三亚的旅游信息，供用户参考：

### 三亚旅游推荐：
1. **亚龙湾**：被誉为“东方夏威夷”，拥有美丽的海滩和清澈的海水，适合游泳和日光浴。
2. **天涯海角**：三亚的标志性景点，以其独特的岩石和浪漫的传说吸引游客。
3. **南山文化旅游区**：这里有著名的南山寺和108米高的海上观音像，是佛教文化的重要景点。
4. **蜈支洲岛**：适合潜水和海上运动，岛上有丰富的海洋生物和珊瑚礁。
5. **大东海**：三亚市区内的海滩，交通便利，适合家庭和情侣游玩。

### 其他推荐：
如果用户对三亚已经有所了解，或者想要探索其他目的地，以下是一些其他热门旅游地：
1. **桂林**：以其独特的喀斯特地貌和漓江风光闻名。
2. **丽江**：古城和玉龙雪山是其主要景点，适合喜欢历史文化和自然风光的游客。
3. **张家界**：以其奇特的石柱和自然景观著称，是《阿凡达》电影的取景地之一。

用户可以根据自己的兴趣和时间安排选择合适的旅游目的地。如果用户需要更详细的信息或帮助规划行程，请随时告知！
```

### 2. Интеграция инструментов (неограниченная поддержка настраиваемых инструментов)
Принятие индивидуальной настройки инструментов (`Tools`), и легкая интеграция ваших специализированных инструментов через метод `tools`. Эти инструменты могут быть любыми функциями Python и поддерживают аннотацию типов параметров для обеспечения гибкости и точности. Кроме того, мы предоставляем генератор инструментов, управляемый AI, чтобы помочь вам автоматически создавать инструменты, освобождая вашу креативность.

```python

import requests
from LightAgent import LightAgent

# Определение инструмента
def get_weather(
        city_name: str
) -> str:
    """
    Получить информацию о погоде в городе
    :param city_name: Название города
    :return: Информация о погоде
    """
    if not isinstance(city_name, str):
        raise TypeError("Название города должно быть строкой")

    key_selection = {
        "current_condition": ["temp_C", "FeelsLikeC", "humidity", "weatherDesc", "observation_time"],
    }
    try:
        resp = requests.get(f"https://wttr.in/{city_name}?format=j1")
        resp.raise_for_status()
        resp = resp.json()
        ret = {k: {_v: resp[k][0][_v] for _v in v} for k, v in key_selection.items()}
    except:
        import traceback
        ret = "Ошибка при получении данных о погоде!\n" + traceback.format_exc()

    return str(ret)
# Определение информации об инструменте внутри функции
get_weather.tool_info = {
    "tool_name": "get_weather",
    "tool_description": "获取指定城市的当前天气信息",
    "tool_params": [
        {"name": "city_name", "description": "要查询的城市名称", "type": "string", "required": True},
    ]
}

def search_news(
        keyword: str,
        max_results: int = 5
) -> str:
    """
    Поиск новостей по ключевому слову
    :param keyword: Ключевое слово для поиска
    :param max_results: Максимальное количество возвращаемых результатов, по умолчанию 5
    :return: Результаты поиска новостей
    """
    results = f"通过搜索{keyword}, 我找到{max_results}条相关信息"
    return str(results)

# Определение информации об инструменте внутри функции
search_news.tool_info = {
    "tool_name": "search_news",
    "tool_description": "根据关键词搜索新闻",
    "tool_params": [
        {"name": "keyword", "description": "搜索关键词", "type": "string", "required": True},
        {"name": "max_results", "description": "返回的最大结果数量", "type": "int", "required": False},
    ]
}

def get_user_info(
        user_id: str
) -> str:
    """
    Получить информацию о пользователе
    :param user_id: ID пользователя
    :return: Информация о пользователе
    """
    if not isinstance(user_id, str):
        raise TypeError("User ID must be a string")

    try:
        # Предполагается использование API для получения информации о пользователе
        url = f"https://api.example.com/users/{user_id}"
        response = requests.get(url) 
        response.raise_for_status()
        user_data = response.json()
        user_info = {
            "name": user_data.get("name"),
            "email": user_data.get("email"),
            "created_at": user_data.get("created_at")
        }
    except:
        import traceback
        user_info = "Ошибка при получении данных о пользователе!\n" + traceback.format_exc()

    return str(user_info)

# Определение информации об инструменте внутри функции
get_user_info.tool_info = {
    "tool_name": "get_user_info",
    "tool_description": "获取指定用户的信息",
    "tool_params": [
        {"name": "user_id", "description": "用户 ID", "type": "string", "required": True},
    ]
}

# Индивидуальные инструменты
tools = [get_weather, search_news, get_user_info]  # Содержит все инструменты

# Инициализация агента
# Замените на параметры вашей модели model、api_key、base_url
agent = LightAgent(model="qwen-turbo-2024-11-01", api_key="your_api_key", base_url= "your_base_url", tools=tools)

query = "当前三亚天气如何？"
response = agent.run(query, stream=False)  # 使用 agent 运行查询
print(response)
```

### 3. Генератор инструментов
Генератор инструментов - это модуль для автоматизированной генерации кода инструментов. Он может автоматически генерировать соответствующий код инструментов на основе текстового описания, предоставленного пользователем, и сохранять его в указанной директории. Эта функция особенно полезна для быстрого создания API-вызовов, инструментов для обработки данных и т.д.

Пример использования

Вот пример кода, использующего генератор инструментов:

```python
import json
import os
import sys
from LightAgent import LightAgent

# Инициализация LightAgent
agent = LightAgent(
    name="Agent A",  # Название агента
    instructions="You are a helpful agent.",  # Описание роли
    role="请记住你是工具生成器，你的任务是根据用户提供的文本描述，自动生成相应的工具代码，并将其保存到指定的目录中。请确保生成的代码准确、可用，并符合用户的需求。",  # Описание роли генератора инструментов
    model="deepseek-chat",  # Замените на вашу модель. Поддерживаемые модели: openai, chatglm, deepseek, qwen и др.
    api_key="your_api_key",  # Замените на ваш API ключ
    base_url="your_base_url",  # Замените на ваш api URL
)

# Пример текстового описания
text = """
新浪股票接口提供了获取股票市场数据的功能，包括股票行情、实时交易数据、K线图数据等。

新浪股票接口功能介绍
1、获取股票行情数据：
实时行情数据：使用实时行情API可以获取股票的最新报价、成交量、涨跌幅等信息。
分钟线行情数据：使用分钟线行情API可以获取股票的逐分钟交易数据，包括开盘价、收盘价、最高价、最低价等。

2、获取股票历史K线图数据：
K线图数据：通过K线图API，可以获取股票的历史交易数据，包括开盘价、收盘价、最高价、最低价、成交量等。可以根据需要选择不同的时间周期和均线周期。
复权数据：可以选择获取复权后的K线图数据，包括前复权和后复权，以便更准确地分析股票的价格变动。

新浪股票接口获取数据示例
1、获取股票行情数据：
API地址：http://hq.sinajs.cn/list=[股票代码]
示例：要获取股票代码为"sh600519"（贵州茅台）的实时行情数据，可以使用以下API地址：http://hq.sinajs.cn/list=sh600519
通过发送HTTP GET请求到上述API地址，你将收到一个包含该股票实时行情数据的响应。

2、获取股票历史K线图数据：
API地址：http://money.finance.sina.com.cn/quotes_service/api/json_v2.php/CN_MarketData.getKLineData?symbol=[股票代码]&scale=[时间周期]&ma=[均线周期]&datalen=[数据长度]
示例：要获取股票代码为"sh600519"（贵州茅台）的日线K线图数据，可以使用以下API地址：http://money.finance.sina.com.cn/quotes_service/api/json_v2.php/CN_MarketData.getKLineData?symbol=sh600519&scale=240&ma=no&datalen=1023
通过发送HTTP GET请求到上述API地址，你将收到一个包含该股票历史K线图数据的响应。
"""

# Путь к директории инструментов
project_root = os.path.dirname(os.path.abspath(__file__))
tools_directory = os.path.join(project_root, "tools")

# Если директория tools не существует, создайте ее
if not os.path.exists(tools_directory):
    os.makedirs(tools_directory)

print(f"Инструменты директории созданы: {tools_directory}")

# Используйте агент для создания кода инструментов
agent.create_tool(text, tools_directory=tools_directory)
```

В результате выполнения в директории tools будет сгенерировано 2 файла: get_stock_kline_data.py и get_stock_realtime_data.py

### 4. Дерево размышлений (ToT)
Встроенный модуль дерева размышлений, поддерживающий разбиение сложных задач и многошаговое вывода. С помощью дерева размышлений агент может лучше справляться со сложными задачами.

```python
# Включите дерево размышлений
agent = LightAgent(
    model="qwen-turbo-2024-11-01", 
    api_key="your_api_key", 
    base_url= "your_base_url", 
    tree_of_thought=True,  # Включите дерево размышлений
)
```

### 5. Многомагистральное взаимодействие
Поддержка многомагистрального взаимодействия между агентами, повышающая эффективность обработки задач. Несколько агентов могут совместно решать сложные задачи.

```python
from LightAgent import LightAgent, LightSwarm
# Установите переменные окружения OPENAI_API_KEY и OPENAI_BASE_URL
# Модель по умолчанию использует gpt-4o-mini

# Создание экземпляра LightSwarm
light_swarm = LightSwarm()

# Создание нескольких агентов
agent_a = LightAgent(
    name="Agent A",
    instructions="我是代理A，是前台接待员",
    role="前台接待员，负责接待来访者并提供基本信息指引。每次回答前请前说明自己的身份信息，你只能帮助用户引导至其他角色，不可以直接回答顾客的业务问题。如果当前不发解决用户的问题，请回复：对不起当前我无法提供帮助！",
)

agent_b = LightAgent(
    name="Agent B",
    instructions="我代理B，负责会议室的预定",
    role="会议室预定管理员，负责处理1号、2号、3号会议室的预定、取消和查询。每次回答前请前说明自己的身份信息，并非常客气的回复用户的提问。",
)

agent_c = LightAgent(
    name="Agent C",
    instructions="我是代理C，是技术支持专员，负责处理技术问题。每次回答前请说明自己的身份信息，并尽可能详细地解答用户的技术问题。如果问题超出我的能力范围，请引导用户联系更高级的技术支持。",
    role="技术支持专员，负责处理硬件、软件、网络等技术问题的咨询和解决。",
)

agent_d = LightAgent(
    name="Agent D",
    instructions="我是代理D，是人力资源专员，负责处理人力资源相关的问题。每次回答前请说明自己的身份信息，并尽可能详细地解答用户的问题。如果问题需要进一步处理，请引导用户联系人力资源部门。",
    role="人力资源专员，负责处理员工入职、离职、请假、福利等事务的咨询和处理。",
)

# Автоматическая регистрация агентов в экземпляре LightSwarm
light_swarm.register_agent(agent_a, agent_b, agent_c, agent_d)

# Запуск агента A
res = light_swarm.run(agent=agent_a, query="你好，我是Alice，我需要查询王小明是否已经办理入职", stream=False)
print(res)
```
Вывод будет следующим:
```python
你好，我是人力资源专员Agent D。关于王小明是否已经办理入职的问题，我需要查询一下我们的系统记录。请稍等片刻。
（查询系统记录中...）
根据我们的记录，王小明已于2025年1月5日完成了入职手续。他已经签署了所有必要的文件，并且已经分配了员工编号和办公位置。如果您需要进一步的详细信息，或者有任何其他问题，请随时联系人力资源部门。我们随时准备帮助您。
```

### 6. Потоковое API 
Поддержка вывода услуг API в формате потока OpenAI, без шва интегрируется с основными чат-фреймворками.

```python
# Включите потоковый вывод
response = agent.run("请生成一篇关于 AI 的文章", stream=True)
for chunk in response:
    print(chunk)
```

### 7. Тестирование агентов (скоро в выпуске)
Встроенные инструменты тестирования агентов для удобной оценки и оптимизации производительности агентов.




## Поддержка основных моделей агент
Совместимость с различными крупными моделями, включая OpenAI, ChatGLM от Zhihui, DeepSeek, и серии Qwen.

#### На данный момент протестированные крупные модели
Серия Openai
 - gpt-3.5-turbo
 - gpt-4
 - gpt-4o
 - gpt-4o-mini

Серия Deepseek
 - DeepSeek-chat (API)
 - DeepSeekv2.5
 - DeepSeekv3

Серия Stepping Stars
 - step-1-8k
 - step-1-32k
 - step-1-128k (проблемы в вызовах множества инструментов)
 - step-1-256k (проблемы в вызовах множества инструментов)
 - step-1-flash (рекомендуется использовать эту модель, оптимальное соотношение цена/качество)
 - step-2-16k (проблемы в вызовах множества инструментов)


Серия Qwen
 - qwen-plus-2024-11-25
 - qwen-plus-2024-11-27
 - qwen-plus-1220
 - qwen-plus
 - qwen-plus-latest 
 - qwen2.5-72b-instruct
 - qwen2.5-32b-instruct
 - qwen2.5-14b-instruct
 - qwen2.5-7b-instruct 
 - qwen-turbo-latest
 - qwen-turbo-2024-11-01
 - qwen-turbo
 - qwen-long




---

## Сценарии использования

- **Интеллектуальные клиенты**: Обеспечивают эффективную поддержку клиентов с помощью многоходовых диалогов и интеграции инструментов.
- **Анализ данных**: Используйте дерево размышлений и многомагистральное взаимодействие для обработки сложных задач анализа данных.
- **Автоматизированные инструменты**: Быстро создавайте индивидуализированные инструменты через автоматизированную генерацию инструментов.
- **Учебная вспомогательная программа**: Индивидуализированный учебный опыт через модуль памяти и потоковое API.

---
 
## 🛠️ Руководство по вкладам

Мы приветствуем любые формы вкладов! Независимо от того, писать код, документацию, тестирование или обратную связь, это будет огромной помощью для проекта. Если у вас есть хорошие идеи или вы обнаружили ошибку, пожалуйста, отправьте issue или pull request. Вот шаги по внесению вклада:

1. **Fork этого проекта**: Нажмите на кнопку `Fork` в правом верхнем углу, чтобы скопировать проект в свой репозиторий GitHub.
2. **Создайте ветку**: Создайте свою ветку разработки локально:  
   ```bash
   git checkout -b feature/YourFeature
   ```
3. **Подайте изменения**: После завершения разработки подайте свои изменения:  
   ```bash
   git commit -m 'Add some feature'
   ```
4. **Пуш ветки**: Отправьте ветку в свое удаленное хранилище:  
   ```bash
   git push origin feature/YourFeature
   ```
5. **Отправить Pull Request**: Создайте Pull Request на GitHub и опишите изменения.

Мы будем рады рассмотреть ваш вклад в кратчайшие сроки, спасибо за вашу поддержку!❤️

---

## 🙏 Благодарности

Разработка и реализация LightAgent были возможны благодаря вдохновению и поддержке следующих открытых проектов, особенно благодарим эти замечательные проекты и команды:

- **mem0**: Спасибо [mem0](https://github.com/mem0ai/mem0) за предоставление модуля памяти, который обеспечивает мощную поддержку управления контекстом LightAgent.
- **Swarm**: Спасибо [Swarm](https://github.com/openai/swarm) за идеи дизайна многомагстрального взаимодействия, которые легли в основу многомагистральных функций LightAgent.
- **ChatGLM3**: Спасибо [ChatGLM3](https://github.com/THUDM/ChatGLМ3) за поддержку высокопроизводительных моделей на китайском языке и идеи дизайна.
- **Qwen**: Спасибо [Qwen](https://github.com/QwenLM/Qwen) за поддержку высокопроизводительных моделей на китайском языке.
- **DeepSeek-V3**: Спасибо [DeepSeek-V3](https://github.com/deepseek-ai/DeepSeek-V3) за поддержку высокопроизводительных моделей на китайском языке.
- **Stepping Stars**: Спасибо [step](https://www.stepfun.com/) за поддержку высокопроизводительных моделей на китайском языке.

---

## 📄 Лицензия

LightAgent лицензируется по [лицензии Apache 2.0](LICENSE). Вы можете свободно использовать, изменять и распространять этот проект, но, пожалуйста, соблюдайте условия лицензии.

---

## 📬 Свяжитесь с нами

Если у вас есть какие-либо вопросы или предложения, пожалуйста, не стесняйтесь обращаться к нам:

- **Электронная почта**: 156713035@qq.com  
- **GitHub Issues**：[https://github.com/wxai-space/lightagent/issues](https://github.com/wxai-space/lightagent/issues)  

Мы ожидаем обратной связи от вас, чтобы сделать LightAgent еще более мощным!🚀

- **Больше инструментов** 🛠️: Постоянная интеграция большего количества полезных инструментов для удовлетворения большего числа сценариев потребностей.
- **Поддержка большего количества моделей** 🔄: Постоянное расширение поддержки большего числа больших моделей для удовлетворения большего количества сценариев применения.
- **Больше функций** 🎯: Постоянное обновление более полезных функций, ожидайте с нетерпением!
- **Больше документации** 📚: Подробная документация, множество примеров, быстрое освоение, легкая интеграция в ваш проект.
- **Больше поддержки сообщества** 👥: Активное сообщество разработчиков, готовое предоставить помощь и ответы в любое время.
- **Больше оптимизации производительности** ⚡: Постоянная оптимизация производительности для удовлетворения потребностей в высоких нагрузках.
- **Больше открытых вкладов** 🌟: Мы приглашаем вас внести свой вклад в код и вместе создать лучший LightAgent!

---

<p align="center">
  <strong>LightAgent - сделайте интеллект более легким, будущий проще.</strong> 🌈
</p>

 
**LightAgent** —— Легкий, гибкий и мощный активный агентный фреймворк, помогающий вам быстро создавать интеллектуальные приложения!